<?php

/*
	Support class Mini Mail Dashboard Widget
	Copyright (c) 2009 by Marcel Bokhorst
*/

// http://framework.zend.com/
require_once('Zend/Loader.php');
Zend_Loader::loadFile('Zend/Mail.php', dirname(__FILE__), true);
Zend_Loader::loadFile('Zend/Mail/Storage/Pop3.php', dirname(__FILE__), true);
Zend_Loader::loadFile('Zend/Mail/Storage/Imap.php', dirname(__FILE__), true);
Zend_Loader::loadFile('Zend/Mail/Transport/Sendmail.php', dirname(__FILE__), true);
Zend_Loader::loadFile('Zend/Mail/Transport/Smtp.php', dirname(__FILE__), true);

// http://www.chuggnutt.com/html2text.php
if (!class_exists('html2text'))
	require_once('lib/class.html2text.inc');

// http://www.criticaldevelopment.net/xml/doc.php
if (!class_exists('XMLParser'))
	require_once('lib/parser_php5.php');

// Define constants
define('c_wpmm_table_name', 'wpmm_log');
define('c_wpmm_text_domain', 'wp-mini-mail');
define('c_wpmm_sms_max_size', 160);

define('c_wpmm_meta_known', 'wpmm_known');

// General options
define('c_wpmm_option_version', 'wpmm_version');
define('c_wpmm_option_time_format', 'wpmm_time_format');
define('c_wpmm_option_cache_maxage', 'wpmm_cache_maxage');
define('c_wpmm_option_cron_interval', 'wpmm_cron_interval');
define('c_wpmm_option_http_timeout', 'wpmm_http_timout');
define('c_wpmm_option_debug', 'wpmm_debug');
define('c_wpmm_option_clean', 'wpmm_clean');

// Mail options
define('c_wpmm_meta_mail_name', 'wpmm_mail_name');
define('c_wpmm_meta_mail_addr', 'wpmm_mail_addr');
define('c_wpmm_meta_mail_rx', 'wpmm_mail_rx');
define('c_wpmm_meta_mail_tx', 'wpmm_mail_tx');
define('c_wpmm_meta_mail_book', 'wpmm_mail_book');

// POP3 options
define('c_wpmm_meta_pop3_host', 'wpmm_pop3_host');
define('c_wpmm_meta_pop3_port', 'wpmm_pop3_port');
define('c_wpmm_meta_pop3_user', 'wpmm_pop3_user');
define('c_wpmm_meta_pop3_pwd', 'wpmm_pop3_pwd');
define('c_wpmm_meta_pop3_ssl', 'wpmm_pop3_ssl');

// IMAP options
define('c_wpmm_meta_imap_host', 'wpmm_imap_host');
define('c_wpmm_meta_imap_port', 'wpmm_imap_port');
define('c_wpmm_meta_imap_user', 'wpmm_imap_user');
define('c_wpmm_meta_imap_pwd', 'wpmm_imap_pwd');
define('c_wpmm_meta_imap_ssl', 'wpmm_imap_ssl');
define('c_wpmm_meta_imap_folder', 'wpmm_imap_folder');

// SMTP options
define('c_wpmm_meta_smtp_host', 'wpmm_smtp_host');
define('c_wpmm_meta_smtp_port', 'wpmm_smtp_port');
define('c_wpmm_meta_smtp_auth', 'wpmm_smtp_auth');
define('c_wpmm_meta_smtp_user', 'wpmm_smtp_user');
define('c_wpmm_meta_smtp_pwd', 'wpmm_smtp_pwd');
define('c_wpmm_meta_smtp_ssl', 'wpmm_smtp_ssl');

// SMS options
define('c_wpmm_meta_sms_enable', 'wpmm_sms_enable');
define('c_wpmm_meta_sms_notify', 'wpmm_sms_notify');
define('c_wpmm_meta_sms_separator', 'wpmm_sms_separator');
define('c_wpmm_meta_sms_user', 'wpmm_sms_user');
define('c_wpmm_meta_sms_pwd', 'wpmm_sms_pwd');
define('c_wpmm_meta_sms_from', 'wpmm_sms_from');
define('c_wpmm_meta_sms_to', 'wpmm_sms_to');
define('c_wpmm_meta_sms_url', 'wpmm_sms_url');
define('c_wpmm_meta_sms_book', 'wpmm_sms_book');
define('c_wpmm_meta_sms_schedule', 'wpmm_sms_schedule');

// Request arguments
define('c_wpmm_action_arg', 'wpmm_action');
define('c_wpmm_action_list', 'list');
define('c_wpmm_action_msg', 'message');
define('c_wpmm_param_msgid', 'msgid');
define('c_wpmm_action_send', 'send');
define('c_wpmm_param_to', 'to');
define('c_wpmm_param_cc', 'cc');
define('c_wpmm_param_subj', 'subject');
define('c_wpmm_param_phone', 'phone');
define('c_wpmm_param_text', 'text');
define('c_wpmm_action_sms', 'sms');
define('c_wpmm_param_cache', 'cache');
define('c_wpmm_action_cron', 'cron');
define('c_wpmm_action_del', 'delete');
define('c_wpmm_param_nonce', 'nonce');
define('c_wpmm_action_log', 'log');
define('c_wpmm_param_clear', 'clear');
define('c_wpmm_action_headers', 'headers');

// Session
define('c_wpmm_session_cache', 'wpmm_cache');
define('c_wpmm_session_age', 'wpmm_age');

define('c_wpmm_nonce_form', 'wpmm-nonce-from');
define('c_wpmm_nonce_ajax', 'wpmm-nonce-ajax');

// Define class
if (!class_exists('WPMiniMail')) {
	class WPMiniMail {
		// Class variables
		private $main_file = null;
		private $plugin_url = null;

		// Constructor
		function WPMiniMail() {
			$bt = debug_backtrace();
			$this->main_file = $bt[0]['file'];
			$this->plugin_url = WP_PLUGIN_URL . '/' . basename(dirname($this->main_file));

			// Register (de)activation hook
			register_activation_hook($this->main_file, array(&$this, 'wpmm_activate'));
			register_deactivation_hook($this->main_file, array(&$this, 'wpmm_deactivate'));

			// Register actions/filters
			add_action('init', array(&$this, 'wpmm_init'));
			if (is_admin()) {
				add_action('wp_dashboard_setup', array(&$this, 'wpmm_dashboard_setup'));
				add_filter('wpmm_address_book', array(&$this, 'wpmm_address_book_extra'));
			}
			add_filter('cron_schedules', array(&$this, 'wpmm_cron_schedules'));
			add_action('wpmm_cron', array(&$this, 'wpmm_cron'));

			session_start();
		}

		// Handle plugin activation
		function wpmm_activate() {
			if (!get_option(c_wpmm_option_version)) {
				// Set default options
				update_option(c_wpmm_option_version, 1);
				update_option(c_wpmm_option_time_format, get_option('date_format') . ' ' . get_option('time_format'));
				update_option(c_wpmm_option_cache_maxage, 15);
				update_option(c_wpmm_option_cron_interval, 30);
				update_option(c_wpmm_option_http_timeout, 30);
				update_option(c_wpmm_option_clean, false);

				// Create log table
				global $wpdb;
				$table_name = $wpdb->prefix . c_wpmm_table_name;
				if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
					$sql = "CREATE TABLE " . $table_name . "(
					id BIGINT(20) NOT NULL AUTO_INCREMENT,
					time DATETIME NOT NULL,
					user BIGINT(20) NOT NULL,
					severity VARCHAR(20) NOT NULL,
					function VARCHAR(40) NOT NULL,
					text TEXT NOT NULL,
					UNIQUE KEY id (id));";
					require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
					dbDelta($sql);
				}
			}
		}

		// Handle plugin deactivation
		function wpmm_deactivate() {
			// Stop cron job
			wp_clear_scheduled_hook('wpmm_cron');

			// Cleanup data
			if (get_option(c_wpmm_option_clean)) {
				global $wpdb;

				// Delete options
				$rows = $wpdb->get_results("SELECT option_name FROM " . $wpdb->options . " WHERE option_name LIKE 'wpmm_%'");
				foreach ($rows as $row)
					delete_option($row->option_name);

				// Delete user meta values
				$rows = $wpdb->get_results("SELECT user_id, meta_key FROM " . $wpdb->usermeta . " WHERE meta_key LIKE 'wpmm_%'");
				foreach ($rows as $row)
					delete_usermeta($row->user_id, $row->meta_key);

				// Delete log table
				$sql = "DROP TABLE " . $wpdb->prefix . c_wpmm_table_name;
				if ($wpdb->query($sql) === false)
					$wpdb->print_error();

				// Clear cache
				$this->wpmm_clear_cache();
			}
		}

		// Handle initialize
		function wpmm_init() {
			if (is_admin()) {
				// I18n
				load_plugin_textdomain(c_wpmm_text_domain, false, basename(dirname($this->main_file)));

				// Load style sheet
				$css_name = $this->change_extension(basename($this->main_file), '.css');
				if (file_exists(TEMPLATEPATH . '/' . $css_name))
					$css_url = get_bloginfo('template_directory') . '/' . $css_name;
				else
					$css_url = $this->plugin_url . '/' . $css_name;
				wp_register_style('wpmm_style', $css_url);
				wp_enqueue_style('wpmm_style');

				// Enqueue jQuery
				wp_enqueue_script('jquery');
			}
		}

		// Handle dashboard setup
		function wpmm_dashboard_setup() {
			// Register widget
			wp_add_dashboard_widget('wpmm_dashboard', __('Mini Mail', c_wpmm_text_domain), array(&$this, 'wpmm_dashboard'), array(&$this, 'wpmm_configure'));
		}

		// Handle dashboard configuration
		function wpmm_configure() {
			// Get current user
			global $user_ID;
			get_currentuserinfo();

			// Security
			wp_nonce_field(c_wpmm_nonce_form);

			// Check post back
			if (strtolower($_SERVER['REQUEST_METHOD']) == 'post' && isset($_POST['widget_id']) && $_POST['widget_id'] == 'wpmm_dashboard') {
				// Check security
				check_admin_referer(c_wpmm_nonce_form);

				// General
				if (current_user_can('manage_options')) {
					update_option(c_wpmm_option_time_format, $_POST[c_wpmm_option_time_format]);
					update_option(c_wpmm_option_cache_maxage, intval($_POST[c_wpmm_option_cache_maxage]));
					update_option(c_wpmm_option_cron_interval, intval($_POST[c_wpmm_option_cron_interval]));
					update_option(c_wpmm_option_http_timeout, intval($_POST[c_wpmm_option_http_timeout]));
					update_option(c_wpmm_option_debug, $_POST[c_wpmm_option_debug]);
					update_option(c_wpmm_option_clean, $_POST[c_wpmm_option_clean]);
				}

				// Mail
				update_usermeta($user_ID, c_wpmm_meta_mail_name, $_POST[c_wpmm_meta_mail_name]);
				update_usermeta($user_ID, c_wpmm_meta_mail_addr, $_POST[c_wpmm_meta_mail_addr]);
				update_usermeta($user_ID, c_wpmm_meta_mail_rx, $_POST[c_wpmm_meta_mail_rx]);
				update_usermeta($user_ID, c_wpmm_meta_mail_tx, $_POST[c_wpmm_meta_mail_tx]);
				update_usermeta($user_ID, c_wpmm_meta_mail_book, $_POST[c_wpmm_meta_mail_book]);

				// POP3
				update_usermeta($user_ID, c_wpmm_meta_pop3_host, $_POST[c_wpmm_meta_pop3_host]);
				update_usermeta($user_ID, c_wpmm_meta_pop3_port, intval($_POST[c_wpmm_meta_pop3_port]));
				update_usermeta($user_ID, c_wpmm_meta_pop3_user, $_POST[c_wpmm_meta_pop3_user]);
				update_usermeta($user_ID, c_wpmm_meta_pop3_pwd, $_POST[c_wpmm_meta_pop3_pwd]);
				update_usermeta($user_ID, c_wpmm_meta_pop3_ssl, $_POST[c_wpmm_meta_pop3_ssl]);

				// IMAP
				update_usermeta($user_ID, c_wpmm_meta_imap_host, $_POST[c_wpmm_meta_imap_host]);
				update_usermeta($user_ID, c_wpmm_meta_imap_port, intval($_POST[c_wpmm_meta_imap_port]));
				update_usermeta($user_ID, c_wpmm_meta_imap_user, $_POST[c_wpmm_meta_imap_user]);
				update_usermeta($user_ID, c_wpmm_meta_imap_pwd, $_POST[c_wpmm_meta_imap_pwd]);
				update_usermeta($user_ID, c_wpmm_meta_imap_ssl, $_POST[c_wpmm_meta_imap_ssl]);
				update_usermeta($user_ID, c_wpmm_meta_imap_folder, $_POST[c_wpmm_meta_imap_folder]);

				// SMTP
				update_usermeta($user_ID, c_wpmm_meta_smtp_host, $_POST[c_wpmm_meta_smtp_host]);
				update_usermeta($user_ID, c_wpmm_meta_smtp_port, intval($_POST[c_wpmm_meta_smtp_port]));
				update_usermeta($user_ID, c_wpmm_meta_smtp_auth, $_POST[c_wpmm_meta_smtp_auth]);
				update_usermeta($user_ID, c_wpmm_meta_smtp_user, $_POST[c_wpmm_meta_smtp_user]);
				update_usermeta($user_ID, c_wpmm_meta_smtp_pwd, $_POST[c_wpmm_meta_smtp_pwd]);
				update_usermeta($user_ID, c_wpmm_meta_smtp_ssl, $_POST[c_wpmm_meta_smtp_ssl]);

				// SMS
				update_usermeta($user_ID, c_wpmm_meta_sms_enable, $_POST[c_wpmm_meta_sms_enable]);
				update_usermeta($user_ID, c_wpmm_meta_sms_notify, $_POST[c_wpmm_meta_sms_notify]);
				update_usermeta($user_ID, c_wpmm_meta_sms_separator, $_POST[c_wpmm_meta_sms_separator]);
				update_usermeta($user_ID, c_wpmm_meta_sms_user, $_POST[c_wpmm_meta_sms_user]);
				update_usermeta($user_ID, c_wpmm_meta_sms_pwd, $_POST[c_wpmm_meta_sms_pwd]);
				update_usermeta($user_ID, c_wpmm_meta_sms_from, $_POST[c_wpmm_meta_sms_from]);
				update_usermeta($user_ID, c_wpmm_meta_sms_to, $_POST[c_wpmm_meta_sms_to]);
				update_usermeta($user_ID, c_wpmm_meta_sms_url, $_POST[c_wpmm_meta_sms_url]);
				update_usermeta($user_ID, c_wpmm_meta_sms_book, $_POST[c_wpmm_meta_sms_book]);
				update_usermeta($user_ID, c_wpmm_meta_sms_schedule, $_POST[c_wpmm_meta_sms_schedule]);

				$this->wpmm_log($user_ID, 'info', __('Settings updated', c_wpmm_text_domain));
				$this->wpmm_clear_cache();
			}

			// Render options form
?>
			<div id="wpmm-options">
<?php		if (current_user_can('manage_options')) { ?>
			<a href="#" class="wpmm-toggle" data-id="wpmm-options-general"><?php _e('General', c_wpmm_text_domain); ?></a>
			<div id="wpmm-options-general" style="display:none;">
			<p>
				<label for="wpmm_time_format"><?php _e('Time format:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_time_format" class="wpmm-input-medium" name="<?php echo c_wpmm_option_time_format; ?>" type="text" value="<?php echo get_option(c_wpmm_option_time_format); ?>" />
				<a href="http://www.php.net/date" target="_blank"><?php _e('Details', c_wpmm_text_domain); ?></a>
			</p>
			<p>
				<label for="wpmm_cache_maxage"><?php _e('Max. cache age:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_cache_maxage" class="wpmm-input-numeric" name="<?php echo c_wpmm_option_cache_maxage; ?>" type="text" value="<?php echo get_option(c_wpmm_option_cache_maxage); ?>" />
				<span class="wpmm-explanation"><?php _e('Minutes', c_wpmm_text_domain); ?></span>
			</p>
			<p>
				<label for="wpmm_opt_cron"><?php _e('Mail check interval:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_opt_cron" class="wpmm-input-numeric" name="<?php echo c_wpmm_option_cron_interval; ?>" type="text" value="<?php echo get_option(c_wpmm_option_cron_interval); ?>" />
				<span class="wpmm-explanation"><?php _e('Minutes', c_wpmm_text_domain); ?></span>
			</p>
			<p>
				<label for="wpmm_opt_http"><?php _e('HTTP time-out:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_opt_http" class="wpmm-input-numeric" name="<?php echo c_wpmm_option_http_timeout; ?>" type="text" value="<?php echo get_option(c_wpmm_option_http_timeout); ?>" />
				<span class="wpmm-explanation"><?php _e('Seconds', c_wpmm_text_domain); ?></span>
			</p>
			<p>
				<label for="wpmm_opt_debug"><?php _e('Debug:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_opt_debug" name="<?php echo c_wpmm_option_debug; ?>" type="checkbox"<?php if (get_option(c_wpmm_option_debug)) echo ' checked="checked"'; ?> />
			</p>
			<p>
				<label for="wpmm_opt_clean"><?php _e('Clean on deactivate:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_opt_clean" name="<?php echo c_wpmm_option_clean; ?>" type="checkbox"<?php if (get_option(c_wpmm_option_clean)) echo ' checked="checked"'; ?> />
			</p>
			<br />
			</div>
<?php		} ?>

			<a href="#" class="wpmm-toggle" data-id="wpmm-options-mail"><?php _e('Mail', c_wpmm_text_domain); ?></a>
			<div id="wpmm-options-mail" style="display:none;">
			<p>
				<label for="wpmm_mail_name"><?php _e('Your name:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_mail_name" name="<?php echo c_wpmm_meta_mail_name; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_mail_name); ?>" />
			</p>
			<p>
				<label for="wpmm_mail_addr"><?php _e('Your e-mail:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_mail_addr" name="<?php echo c_wpmm_meta_mail_addr; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_mail_addr); ?>" />
			</p>
			<p>
				<?php $rx = get_usermeta($user_ID, c_wpmm_meta_mail_rx); ?>
				<td><label for="wpmm_mail_rx"><?php _e('Receive method:', c_wpmm_text_domain); ?></label></td>
				<select id="wpmm_mail_rx" name="<?php echo c_wpmm_meta_mail_rx; ?>">
				<option value=""<?php if (!$rx) echo ' selected'; ?>><?php _e('Off', c_wpmm_text_domain); ?></option>
				<option value="POP3"<?php if ($rx == 'POP3') echo ' selected'; ?>>POP3</option>
				<option value="IMAP"<?php if ($rx == 'IMAP') echo ' selected'; ?>>IMAP</option>
				</select>
			</p>
			<p>
				<?php $tx = get_usermeta($user_ID, c_wpmm_meta_mail_tx); ?>
				<td><label for="wpmm_mail_tx"><?php _e('Send method:', c_wpmm_text_domain); ?></label></td>
				<select id="wpmm_mail_tx" name="<?php echo c_wpmm_meta_mail_tx; ?>">
				<option value=""<?php if (!$tx) echo ' selected'; ?>><?php _e('Off', c_wpmm_text_domain); ?></option>
				<option value="Sendmail"<?php if ($tx == 'Sendmail') echo ' selected'; ?>>PHP mail</option>
				<option value="SMTP"<?php if ($tx == 'SMTP') echo ' selected'; ?>>SMTP</option>
				</select>
			</p>
			<p>
				<label for="wpmm_mail_book"><?php _e('Address book:', c_wpmm_text_domain); ?></label>
				<br />
				<textarea id="wpmm_mail_book" name="<?php echo c_wpmm_meta_mail_book; ?>"><?php echo get_usermeta($user_ID, c_wpmm_meta_mail_book); ?></textarea>
				<span class="wpmm-explanation">John Doe &lt;john.doe@example.org&gt;</span>
			</p>
			<br />
			</div>

			<a href="#" class="wpmm-toggle" data-id="wpmm-options-pop3"><?php _e('POP3', c_wpmm_text_domain); ?></a>
			<div id="wpmm-options-pop3" style="display:none;">
			<p>
				<label for="wpmm_pop3_host"><?php _e('Host:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_pop3_host" name="<?php echo c_wpmm_meta_pop3_host; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_pop3_host); ?>" />
				<a href="http://www.emailaddressmanager.com/tips/mail-settings.html" target="_blank"><?php _e('Frequenty used', c_wpmm_text_domain); ?></a>
			</p>
			<p>
				<?php $ssl = get_usermeta($user_ID, c_wpmm_meta_pop3_ssl); ?>
				<td><label for="wpmm_pop3_ssl"><?php _e('Secure transfer:', c_wpmm_text_domain); ?></label></td>
				<select id="wpmm_pop3_ssl" name="<?php echo c_wpmm_meta_pop3_ssl; ?>">
				<option value=""<?php if (!$ssl) echo ' selected'; ?>>-</option>
				<option value="SSL"<?php if ($ssl == 'SSL') echo ' selected'; ?>>SSL</option>
				<option value="TLS"<?php if ($ssl == 'TSL') echo ' selected'; ?>>TLS</option>
				</select>
			</p>
			<p>
				<label for="wpmm_pop3_port"><?php _e('Port:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_pop3_port" class="wpmm-input-numeric" name="<?php echo c_wpmm_meta_pop3_port; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_pop3_port); ?>" />
			</p>
			<p>
				<label for="wpmm_pop3_user"><?php _e('User name:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_pop3_user" name="<?php echo c_wpmm_meta_pop3_user; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_pop3_user); ?>" />
			</p>
			<p>
				<label for="wpmm_pop3_pwd"><?php _e('Password:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_pop3_pwd" name="<?php echo c_wpmm_meta_pop3_pwd; ?>" type="password" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_pop3_pwd); ?>" />
			</p>
			<br />
			</div>

			<a href="#" class="wpmm-toggle" data-id="wpmm-options-imap"><?php _e('IMAP', c_wpmm_text_domain); ?></a>
			<div id="wpmm-options-imap" style="display:none;">
			<p>
				<label for="wpmm_imap_host"><?php _e('Host:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_imap_host" name="<?php echo c_wpmm_meta_imap_host; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_imap_host); ?>" />
			</p>
			<p>
				<?php $ssl = get_usermeta($user_ID, c_wpmm_meta_imap_ssl); ?>
				<td><label for="wpmm_imap_ssl"><?php _e('Secure transfer:', c_wpmm_text_domain); ?></label></td>
				<select id="wpmm_imap_ssl" name="<?php echo c_wpmm_meta_imap_ssl; ?>">
				<option value=""<?php if (!$ssl) echo ' selected'; ?>>-</option>
				<option value="SSL"<?php if ($ssl == 'SSL') echo ' selected'; ?>>SSL</option>
				<option value="TLS"<?php if ($ssl == 'TSL') echo ' selected'; ?>>TLS</option>
				</select>
			</p>
			<p>
				<label for="wpmm_imap_port"><?php _e('Port:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_imap_port" class="wpmm-input-numeric" name="<?php echo c_wpmm_meta_imap_port; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_imap_port); ?>" />
			</p>
			<p>
				<label for="wpmm_imap_user"><?php _e('User name:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_imap_user" name="<?php echo c_wpmm_meta_imap_user; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_imap_user); ?>" />
			</p>
			<p>
				<label for="wpmm_imap_pwd"><?php _e('Password:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_imap_pwd" name="<?php echo c_wpmm_meta_imap_pwd; ?>" type="password" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_imap_pwd); ?>" />
			</p>
			<p>
				<label for="wpmm_imap_folder"><?php _e('Folder:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_imap_folder" name="<?php echo c_wpmm_meta_imap_folder; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_imap_folder); ?>" />
			</p>
			<br />
			</div>

			<a href="#" class="wpmm-toggle" data-id="wpmm-options-smtp"><?php _e('SMTP', c_wpmm_text_domain); ?></a>
			<div id="wpmm-options-smtp" style="display:none;">
			<p>
				<label for="wpmm_smtp_host"><?php _e('Host:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_smtp_host" name="<?php echo c_wpmm_meta_smtp_host; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_smtp_host); ?>" />
				<a href="http://www.emailaddressmanager.com/tips/mail-settings.html" target="_blank"><?php _e('Frequenty used', c_wpmm_text_domain); ?></a>
			</p>
			<p>
				<?php $ssl = get_usermeta($user_ID, c_wpmm_meta_smtp_ssl); ?>
				<td><label for="wpmm_smtp_ssl"><?php _e('Secure transfer:', c_wpmm_text_domain); ?></label></td>
				<select id="wpmm_smtp_ssl" name="<?php echo c_wpmm_meta_smtp_ssl; ?>">
				<option value=""<?php if (!$ssl) echo ' selected'; ?>>-</option>
				<option value="SSL"<?php if ($ssl == 'SSL') echo ' selected'; ?>>SSL</option>
				<option value="TLS"<?php if ($ssl == 'TLS') echo ' selected'; ?>>TLS</option>
				</select>
			</p>
			<p>
				<label for="wpmm_smtp_port"><?php _e('Port:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_smtp_port" class="wpmm-input-numeric" name="<?php echo c_wpmm_meta_smtp_port; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_smtp_port); ?>" />
			</p>
			<p>
				<?php $auth = get_usermeta($user_ID, c_wpmm_meta_smtp_auth); ?>
				<td><label for="wpmm_smtp_auth"><?php _e('Authentication:', c_wpmm_text_domain); ?></label></td>
				<select id="wpmm_smtp_auth" name="<?php echo c_wpmm_meta_smtp_auth; ?>">
				<option value=""<?php if (!$auth) echo ' selected'; ?>>-</option>
				<option value="Plain"<?php if ($auth == 'Plain') echo ' selected'; ?>>Plain</option>
				<option value="Login"<?php if ($auth == 'Login') echo ' selected'; ?>>Login</option>
				<option value="Crammd5"<?php if ($auth == 'Crammd5') echo ' selected'; ?>>Crammd5</option>
				</select>
			</p>
			<p>
				<label for="wpmm_smtp_user"><?php _e('User name:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_smtp_user" name="<?php echo c_wpmm_meta_smtp_user; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_smtp_user); ?>" />
			</p>
			<p>
				<label for="wpmm_smtp_pwd"><?php _e('Password:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_smtp_pwd" name="<?php echo c_wpmm_meta_smtp_pwd; ?>" type="password" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_smtp_pwd); ?>" />
			</p>
			<br />
			</div>

			<a href="#" class="wpmm-toggle" data-id="wpmm-options-sms"><?php _e('SMS', c_wpmm_text_domain); ?></a>
			<div id="wpmm-options-sms" style="display:none;">
			<p>
				<a href="http://progx.ch/home-voip-smsbetamax-3-1-1.html" target="_blank">
				<em><?php _e('Use VoipBuster or one of its clones', c_wpmm_text_domain); ?></a></em>
			</p>
			<p>
				<label for="wpmm_sms_enable"><?php _e('Enable:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_enable" name="<?php echo c_wpmm_meta_sms_enable; ?>" type="checkbox"<?php if (get_usermeta($user_ID,  c_wpmm_meta_sms_enable)) echo ' checked="checked"'; ?> />
			</p>
			<p>
				<label for="wpmm_sms_notify"><?php _e('Notifications:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_notify" name="<?php echo c_wpmm_meta_sms_notify; ?>" type="checkbox"<?php if (get_usermeta($user_ID,  c_wpmm_meta_sms_notify)) echo ' checked="checked"'; ?> />
			</p>
			<p>
				<label for="wpmm_sms_sepa"><?php _e('Separator:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_sepa" class="wpmm-input-small" name="<?php echo c_wpmm_meta_sms_separator; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_sms_separator); ?>" />
				<span class="wpmm-explanation"><?php _e('Between from/subject/text; default space', c_wpmm_text_domain); ?></span>
			</p>
			<p>
				<label for="wpmm_sms_user"><?php _e('User name:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_user" name="<?php echo c_wpmm_meta_sms_user; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_sms_user); ?>" />
			</p>
			<p>
				<label for="wpmm_sms_pwd"><?php _e('Password:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_pwd" name="<?php echo c_wpmm_meta_sms_pwd; ?>" type="password" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_sms_pwd); ?>" />
			</p>
			<p>
				<label for="wpmm_sms_from"><?php _e('From number:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_from" name="<?php echo c_wpmm_meta_sms_from; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_sms_from); ?>" />
			</p>
			<p>
				<label for="wpmm_sms_to"><?php _e('Notifications to:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_to" name="<?php echo c_wpmm_meta_sms_to; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_sms_to); ?>" />
			</p>
			<p>
				<label for="wpmm_sms_url"><?php _e('Url:', c_wpmm_text_domain); ?></label>
				<input id="wpmm_sms_url" class="wpmm-input-large" name="<?php echo c_wpmm_meta_sms_url; ?>" type="text" value="<?php echo get_usermeta($user_ID, c_wpmm_meta_sms_url); ?>" />
				<a href="#" id="wpmm-sms-url-default"><?php _e('VoipBuster', c_wpmm_text_domain); ?></a>
			</p>
			<p>
				<label for="wpmm_sms_phone"><?php _e('Phone book:', c_wpmm_text_domain); ?></label>
				<br />
				<textarea id="wpmm_sms_phone" name="<?php echo c_wpmm_meta_sms_book; ?>"><?php echo get_usermeta($user_ID, c_wpmm_meta_sms_book); ?></textarea>
				<span class="wpmm-explanation">John Doe &lt;+012345678&gt;</span>
			</p>
			<p>
				<label for="wpmm_sms_sched"><?php _e('Schedule:', c_wpmm_text_domain); ?></label>
				<br />
				<textarea id="wpmm_sms_sched" name="<?php echo c_wpmm_meta_sms_schedule; ?>"><?php echo get_usermeta($user_ID, c_wpmm_meta_sms_schedule); ?></textarea>
				<span class="wpmm-explanation"><?php _e('Works like a mechanical time switch; lines starting with + switches on, with - off.', c_wpmm_text_domain); ?></span>
				<a href="http://www.php.net/strtotime" target="_blank"><?php _e('Details', c_wpmm_text_domain); ?></a>
			</p>
			<br />
			</div>
			<span class="wpmm-explanation"><?php _e('All passwords are stored and sent in plain text', c_wpmm_text_domain); ?></span>

			</div>

			<script type="text/javascript">
			/* <![CDATA[ */
			jQuery(document).ready(function($) {
				$('#wpmm_pop3_ssl').change(function() {
					var ssl = $('#wpmm_pop3_ssl option:selected').text();
					$('#wpmm_pop3_port').val(ssl == 'SSL' || ssl == 'TLS' ? '995' : '110');
				});

				$('#wpmm_imap_ssl').change(function() {
					var ssl = $('#wpmm_imap_ssl option:selected').text();
					$('#wpmm_imap_port').val(ssl == 'SSL' || ssl == 'TLS' ? '993' : '143');
				});

				$('#wpmm_smtp_ssl').change(function() {
					var ssl = $('#wpmm_smtp_ssl option:selected').text();
					$('#wpmm_smtp_port').val(ssl == 'SSL' || ssl == 'TLS' ? '465' : '25');
				});

				$('#wpmm-sms-url-default').click(function() {
					$('#wpmm_sms_url').val('https://www.voipbuster.com/myaccount/sendsms.php');
					return false;
				});

				$('.wpmm-toggle').click(function() {
					$('#' + $(this).attr('data-id')).toggle();
					return false;
				});
			});
			/* ]]> */
			</script>
<?php
		}

		// Render dashboard widget
		function wpmm_dashboard() {
			// Get current user
			global $user_ID;
			get_currentuserinfo();

			// Security
			$nonce = wp_create_nonce(c_wpmm_nonce_ajax);
?>
			<div id="wpmm-container">
			<div id="wpmm-list"></div>
				<div class="wpmm-action">
<?php			if (get_usermeta($user_ID, c_wpmm_meta_mail_rx)) { ?>
				<a id="wpmm-docheck" href="#"><?php _e('Check', c_wpmm_text_domain); ?></a>
<?php			} ?>
<?php			if (get_usermeta($user_ID, c_wpmm_meta_mail_tx)) { ?>
				<a id="wpmm-docompose" href="#"><?php _e('Compose', c_wpmm_text_domain); ?></a>
<?php			} ?>
<?php			if (get_usermeta($user_ID,  c_wpmm_meta_sms_enable)) { ?>
				<a id="wpmm-dosms" href="#"><?php _e('SMS', c_wpmm_text_domain); ?></a>
<?php			} ?>
				<a id="wpmm-dolog" href="#"><?php _e('Log', c_wpmm_text_domain); ?></a>
				<a id="wpmm-doclear" href="#"><?php _e('Clear', c_wpmm_text_domain); ?></a>
<?php			if (get_option(c_wpmm_option_debug)) { ?>
				<a id="wpmm-docron" href="#"><?php _e('Cron', c_wpmm_text_domain); ?></a>
<?php			} ?>
				<a id="wpmm-dosettings" href="<?php echo admin_url() . 'index.php?edit=wpmm_dashboard#wpmm_dashboard'; ?>"><?php _e('Settings', c_wpmm_text_domain); ?></a>
				<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=AJSBB7DGNA3MJ&lc=US&item_name=Mini%20Mail%20Dashboard%20Widget%20WordPress%20Plugin&item_number=Marcel%20Bokhorst&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donate_SM%2egif%3aNonHosted" target="_blank"><?php _e('Donate', c_wpmm_text_domain); ?></a>
			</div>

			<div id="wpmm-body" style="display:none;">
				<table>
				<tr><td><span class="wpmm-body-title"><?php _e('Date:', c_wpmm_text_domain); ?></span></td>
				<td><span id="wpmm-body-date"></span></td></tr>
				<tr><td><span class="wpmm-body-title"><?php _e('From:', c_wpmm_text_domain); ?></span></td>
				<td><span id="wpmm-body-from"></span></td></tr>
				<tr><td><span class="wpmm-body-title"><?php _e('Subject:', c_wpmm_text_domain); ?></span></td>
				<td><span id="wpmm-body-subj"></span></td></tr>
				</table>
				<div id="wpmm-body-text"></div>
				<div id="wpmm-body-action" class="wpmm-action">
<?php			if (get_usermeta($user_ID, c_wpmm_meta_mail_tx)) { ?>
				<a id="wpmm-doreply" href="#"><?php _e('Reply', c_wpmm_text_domain); ?></a>
				<a id="wpmm-doforward" href="#"><?php _e('Forward', c_wpmm_text_domain); ?></a>
<?php			} ?>
				<a id="wpmm-doclosebody" href="#"><?php _e('Close', c_wpmm_text_domain); ?></a>
				</div>
			</div>

			<div id="wpmm-compose" style="display:none">
				<form action="#" method="post">
				<table>
				<tr class="wpmm-row-msg"><td class="wpmm-form-title"><?php _e('To:', c_wpmm_text_domain); ?></td>
				<td>
				<input type="text" name="wpmm-to" class="wpmm-msgenable wpmm-msgval" />
				<select id="wpmm-addr-book">
				<option value=""><?php _e('Select', c_wpmm_text_domain); ?></option>
<?php
				$book = explode("\n", get_usermeta($user_ID, c_wpmm_meta_mail_book));
				$book = apply_filters('wpmm_address_book', $book);
				natcasesort($book);
				foreach ($book as $line)
					if (trim($line) != '') {
						$addr = $this->wpmm_parse_addr($line);
						echo '<option value="' . $this->wpmm_format_addr($addr) . '">';
						echo $this->wpmm_readable_addr($addr) . '</option>' . PHP_EOL;
					}
?>
				</select>
				</td></tr>
				<tr class="wpmm-row-msg"><td class="wpmm-form-title"><?php _e('CC:', c_wpmm_text_domain); ?></td>
				<td><input type="text" name="wpmm-cc" class="wpmm-msgenable wpmm-msgval" /></td></tr>
				<tr class="wpmm-row-msg"><td class="wpmm-form-title"><?php _e('Subject:', c_wpmm_text_domain); ?></td>
				<td><input type="text" name="wpmm-subj" class="wpmm-msgenable wpmm-msgval" /></td></tr>
				<tr class="wpmm-row-sms"><td class="wpmm-form-title"><?php _e('Phone:', c_wpmm_text_domain); ?></td>
				<td>
				<input type="text" name="wpmm-phone" class="wpmm-msgenable wpmm-msgval" />
				<select id="wpmm-phone-book">
				<option value=""><?php _e('Select', c_wpmm_text_domain); ?></option>
<?php
				$book = explode("\n", get_usermeta($user_ID, c_wpmm_meta_sms_book));
				$book = apply_filters('wpmm_phone_book', $book);
				natcasesort($book);
				foreach ($book as $line) 
					if (trim($line) != '') {
						$addr = $this->wpmm_parse_addr($line);
						echo '<option value="' . $addr['email'] . '">';
						echo $this->wpmm_readable_addr($addr) . '</option>' . PHP_EOL;
					}
?>
				</select>
				</td></tr>
				</table>
				<textarea name="wpmm-msgtext" class="wpmm-msgenable wpmm-msgval"></textarea><br />
				<input type="submit" name="wpmm-send-msg" class="wpmm-msgenable button-primary" value="<?php _e('Send', c_wpmm_text_domain); ?>" />
				<input type="button" name="wpmm-cancel-msg" class="wpmm-msgenable button" value="<?php _e('Cancel', c_wpmm_text_domain); ?>" />
				</form>
				<div id="wpmm-msgstat" class="wpmm-notice"></div>
			</div>

			<div id="wpmm-log" style="display:none;">
				<div id="wpmm-log-text"></div>
				<div class="wpmm-action">
					<a id="wpmm-docloselog" href="#"><?php _e('Close', c_wpmm_text_domain); ?></a>
				</div>
			</div>
			</div>

			<script type="text/javascript">
			/* <![CDATA[ */
			jQuery(document).ready(function($) {
				/* Get mail list */
				$('#wpmm-list').ready(function() {
					var load = $('<img src="<?php echo $this->plugin_url  . '/img/ajax-loader.gif'; ?>" alt="wait" />');
					$('#wpmm-list').html(load);
					$.ajax({
						url: '<?php echo $this->plugin_url  . '/' . basename($this->main_file); ?>',
						type: 'GET',
						data:
						{
							<?php echo c_wpmm_param_nonce; ?>: '<?php echo $nonce; ?>',
							<?php echo c_wpmm_action_arg; ?>: '<?php echo c_wpmm_action_list ?>',
							<?php echo c_wpmm_param_cache; ?>: 'true'
						},
						dataType: 'text',
						cache: false,
						success: function(result) {
							$('#wpmm-list').html(result);
						},
						error: function(x, stat, e) {
							$('#wpmm-list').html('<span class="wpmm-notice">Error ' + x.status + '</span>');
						}
					});
				});

				/* Get or delete message */
				$('#wpmm-list').click(function(e) {
					var a = $(e.target);
					if (a.is('img'))
						a = a.parent();
					if (a.is('a')) {
						var cell = a.parent();
						var row = cell.parent();
						var load = $('<img src="<?php echo $this->plugin_url  . '/img/ajax-loader.gif'; ?>" alt="wait" />');

						/* Get message */
						if (a.get(0).className == 'wpmm-subj') {
							/* Copy meta data */
							$('#wpmm-body').attr('data-from',  row.attr('data-from'));
							$('#wpmm-body').attr('data-subj',  row.attr('data-subj'));
							$('#wpmm-body').attr('data-to',	row.attr('data-to'));
							$('#wpmm-body').attr('data-date',  row.attr('data-date'));
							$('#wpmm-body').attr('data-reply', row.attr('data-reply'));

							/* Visuals */
							$('#wpmm-body-date').text(row.attr('data-date'));
							$('#wpmm-body-from').text(row.attr('data-from'));
							$('#wpmm-body-subj').text(row.attr('data-subj'));
							$('#wpmm-body-text').html(load);
							$('#wpmm-body-action').hide();
							$('#wpmm-body').show();

							/* Async fetch */
							$.ajax({
								url: '<?php echo $this->plugin_url  . '/' . basename($this->main_file); ?>',
								type: 'GET',
								data: {
									<?php echo c_wpmm_param_nonce; ?>: '<?php echo $nonce; ?>',
									<?php echo c_wpmm_action_arg; ?>: '<?php echo c_wpmm_action_msg ?>',
									<?php echo c_wpmm_param_msgid; ?>: row.attr('data-id')
								},
								dataType: 'text',
								cache: false,
								success: function(result) {
									$('#wpmm-body-text').html(result);
									$('#wpmm-body-action').show();
									row.removeClass('wpmm-new-mail');
								},
								error: function(x, stat, e) {
									$('#wpmm-body-text').html('<span class="wpmm-notice">Error ' + x.status + '</span>');
								}
							});
						}

						/* Delete message */
						else if (a.get(0).className == 'wpmm-delete') {
							if (confirm('<?php _e('Are you sure to delete this message?', c_wpmm_text_domain); ?>')) {
								/* Visuals */
								a.hide();
								cell.append(load);

								/* Async delete */
								$.ajax({
									url: '<?php echo $this->plugin_url  . '/' . basename($this->main_file); ?>',
									type: 'POST',
									data: {
										<?php echo c_wpmm_param_nonce; ?>: '<?php echo $nonce; ?>',
										<?php echo c_wpmm_action_arg; ?>: '<?php echo c_wpmm_action_del ?>',
										<?php echo c_wpmm_param_msgid; ?>: row.attr('data-id')
									},
									dataType: 'text',
									cache: false,
									success: function(result) {
										if (result == 'OK')
											row.hide();
										else {
											load.remove();
											a.show();
											cell.append('<span class="wpmm-notice">' + result + '</span>');
										}
									},
									error: function(x, stat, e) {
										load.remove();
										a.show();
										cell.append('<span class="wpmm-notice">Error ' + x.status + '</span>');
									}
								});
							}
						}

						/* Get headers */
						else if (a.get(0).className == 'wpmm-headers') {
							a.hide();
							cell.append(load);

							/* Async get headers */
							$.ajax({
								url: '<?php echo $this->plugin_url  . '/' . basename($this->main_file); ?>',
								type: 'GET',
								data: {
									<?php echo c_wpmm_param_nonce; ?>: '<?php echo $nonce; ?>',
									<?php echo c_wpmm_action_arg; ?>: '<?php echo c_wpmm_action_headers ?>',
									<?php echo c_wpmm_param_msgid; ?>: row.attr('data-id')
								},
								dataType: 'text',
								cache: false,
								success: function(result) {
									$('#wpmm-log-text').html(result);
									$('#wpmm-log').show();
									load.remove();
									a.show();
								},
								error: function(x, stat, e) {
									$('#wpmm-log-text').html('<span class="wpmm-notice">Error ' + x.status + '</span>');
									$('#wpmm-log').show();
									load.remove();
									a.show();
								}
							});
						}
					}
					return false;
				});

				/* Check mail / cron */
				$('#wpmm-docheck,#wpmm-docron').click(function() {
					var check = (this.id == 'wpmm-docheck');
					var load = $('<img src="<?php echo $this->plugin_url  . '/img/ajax-loader.gif'; ?>" alt="wait" />');

					/* Visuals */
					if (check)
						$('#wpmm-list').html(load);
					else {
						$('#wpmm-log-text').html(load);
						$('#wpmm-log').show();
					}

					/* Async fetch */
					$.ajax({
						url: '<?php echo $this->plugin_url  . '/' . basename($this->main_file); ?>',
						type: 'GET',
						data: {
							<?php echo c_wpmm_param_nonce; ?>: '<?php echo $nonce; ?>',
							<?php echo c_wpmm_action_arg; ?>:  (check ? '<?php echo c_wpmm_action_list ?>' : '<?php echo c_wpmm_action_cron ?>'),
							<?php echo c_wpmm_param_cache; ?>: 'false'
						},
						dataType: 'text',
						cache: false,
						success: function(result) {
							$(check ? '#wpmm-list' : '#wpmm-log-text').html(result);
						},
						error: function(x, stat, e) {
							$(check ? '#wpmm-list' : '#wpmm-log-text').html('<span class="wpmm-notice">Error ' + x.status + '</span>');
						}
					});
					return false;
				});

				/* Address book */
				$('#wpmm-addr-book').change(function() {
					$('[name=wpmm-to]').val($(this).val());
					return false;
				});

				/* Phone book */
				$('#wpmm-phone-book').change(function() {
					$('[name=wpmm-phone]').val($(this).val());
					return false;
				});

				/* Compose mail / sms */
				$('#wpmm-docompose,#wpmm-dosms').click(function() {
					var sms = (this.id == 'wpmm-dosms');
					$('#wpmm-compose').attr('data-sms', sms);
					$('#wpmm-msgstat').html('');
					$('.wpmm-msgval').val('');
					$("#wpmm-addr-book option[value='']").attr('selected', 'selected');
					$("#wpmm-phone-book option[value='']").attr('selected', 'selected');
					$(sms ? '.wpmm-row-sms' : '.wpmm-row-msg').show();
					$(sms ? '.wpmm-row-msg' : '.wpmm-row-sms').hide();
					$('#wpmm-compose').show();
					$(sms ? '[name=wpmm-phone]' : '[name=wpmm-to]').focus();
					return false;
				});

				/* Show log */
				$('#wpmm-dolog,#wpmm-doclear').click(function() {
					var clear = (this.id == 'wpmm-doclear');
					if (!clear || confirm('<?php _e('Are you sure to clear the log?', c_wpmm_text_domain); ?>')) {
						/* Visuals */
						var load = $('<img src="<?php echo $this->plugin_url  . '/img/ajax-loader.gif'; ?>" alt="wait" />');
						$('#wpmm-log-text').html(load);
						$('#wpmm-log').show();

						/* Async fetch */
						$.ajax({
							url: '<?php echo $this->plugin_url  . '/' . basename($this->main_file); ?>',
							type: 'GET',
							data: {
								<?php echo c_wpmm_param_nonce; ?>: '<?php echo $nonce; ?>',
								<?php echo c_wpmm_action_arg; ?>:  '<?php echo c_wpmm_action_log ?>',
								<?php echo c_wpmm_param_clear; ?>: (clear ? 'true' : 'false')
							},
							dataType: 'text',
							cache: false,
							success: function(result) {
								$('#wpmm-log-text').html(result);
							},
							error: function(x, stat, e) {
								$('#wpmm-log-text').html('<span class="wpmm-notice">Error ' + x.status + '</span>');
							}
						});
					}
					return false;
				});

				/* Reply to / forward message */
				$('#wpmm-doreply,#wpmm-doforward').click(function() {
					var b = $('#wpmm-body');
					var reply = (this.id == 'wpmm-doreply');
					$('wpmm-compose').attr('data-sms', 'false');

					/* Visuals */
					$('#wpmm-msgstat').html('');
					$('.wpmm-msgval').val('');
					if (reply) {
						$('[name=wpmm-to]').val(b.attr('data-reply'));
						$('[name=wpmm-subj]').val('<?php _e('Re: ', c_wpmm_text_domain); ?>' + b.attr('data-subj'));
					}
					else
						$('[name=wpmm-subj]').val('<?php _e('Fwd: ', c_wpmm_text_domain); ?>' + b.attr('data-subj'));
					$('.wpmm-row-msg').show();
					$('.wpmm-row-sms').hide();
					$('#wpmm-compose').show();

					/* Body text */
					var text = '\n\n--- ' + '<?php _e('On', c_wpmm_text_domain); ?>' + ' ' + b.attr('data-date');
					text = text + ' ' + b.attr('data-from') + ' <?php _e('wrote:', c_wpmm_text_domain); ?>\n\n';
					text = text + '<?php _e('From:', c_wpmm_text_domain); ?>' + ' ' + b.attr('data-from') + '\n';
					text = text + '<?php _e('Subject:', c_wpmm_text_domain); ?>' + ' ' + b.attr('data-subj') + '\n';
					text = text + '<?php _e('To:', c_wpmm_text_domain); ?>' + ' ' + b.attr('data-to') + '\n';
					text = text + '<?php _e('Date:', c_wpmm_text_domain); ?>' + ' ' + b.attr('data-date') + '\n';
					text = text + '\n' + $('#wpmm-body-text').text();
					$('[name=wpmm-msgtext]').val(text);

					/* Focus */
					if (reply) {
						var text = $('[name=wpmm-msgtext]');
						if (text.get(0).setSelectionRange)
							text.get(0).setSelectionRange(0, 0);
						else if (text.get(0).createTextRange) {
							var range = text.get(0).createTextRange();
							range.collapse(true);
							range.moveEnd('character', 0);
							range.moveStart('character', 0);
							range.select();
						}
						text.focus();
					}
					else
						$('[name=wpmm-to]').focus();
					return false;
				});

				/* Send mail / sms */
				$('[name=wpmm-send-msg]').click(function() {
					var sms = ($('#wpmm-compose').attr('data-sms') == 'true');
					var load = $('<img src="<?php echo $this->plugin_url  . '/img/ajax-loader.gif'; ?>" alt="wait" />');

					/* Visuals */
					$('#wpmm-msgstat').html(load);
					$('.wpmm-msgenable').attr('disabled', 'disabled');

					/* Post data */
					$.ajax({
						url: '<?php echo $this->plugin_url  . '/' . basename($this->main_file); ?>',
						type: 'POST',
						data: {
							<?php echo c_wpmm_param_nonce; ?>: '<?php echo $nonce; ?>',
							<?php echo c_wpmm_action_arg; ?>: (sms ? '<?php echo c_wpmm_action_sms ?>' : '<?php echo c_wpmm_action_send ?>'),
							<?php echo c_wpmm_param_to; ?>: $('[name=wpmm-to]').val(),
							<?php echo c_wpmm_param_cc; ?>: $('[name=wpmm-cc]').val(),
							<?php echo c_wpmm_param_subj; ?>: $('[name=wpmm-subj]').val(),
							<?php echo c_wpmm_param_phone; ?>: $('[name=wpmm-phone]').val(),
							<?php echo c_wpmm_param_text; ?>: $('[name=wpmm-msgtext]').val()
						},
						dataType: 'text',
						cache: false,
						success: function(result) {
							$('.wpmm-msgenable').removeAttr('disabled');
							$('#wpmm-msgstat').html(result);
						},
						error: function(x, stat, e) {
							$('.wpmm-msgenable').removeAttr('disabled');
							$('#wpmm-msgstat').html('Error ' + x.status);
						}
					});
					return false;
				});

				/* Count characters */
				$('[name=wpmm-msgtext]').keyup(function() {
					if (($('#wpmm-compose').attr('data-sms') == 'true')) {
						var max = <?php echo c_wpmm_sms_max_size; ?>;
						var text = $(this).val();
						if (text.length > max)
							$(this).val(text.substring(0, max));
						$('#wpmm-msgstat').html(max - $(this).val().length);
					}
				});

				/* Close message */
				$('#wpmm-doclosebody').click(function() {
					$('#wpmm-body').hide();
					return false;
				});

				/* Cancel compose */
				$('[name=wpmm-cancel-msg]').click(function() {
					$('#wpmm-compose').hide();
					return false;
				});

				/* Close log */
				$('#wpmm-docloselog').click(function() {
					$('#wpmm-log').hide();
					return false;
				});
			});
			/* ]]> */
			</script>
<?php
		}

		// Add cron schedule
		function wpmm_cron_schedules($schedules) {
			$interval = get_option(c_wpmm_option_cron_interval);
			if ($interval <= 0)
				$interval = 30;
			$schedules['wpmm_schedule'] = array(
				'interval' => $interval * 60,
				'display' => __('Mini Mail', c_wpmm_text_domain));
			return $schedules;
		}

		// Handle cron event
		function wpmm_cron($debug = false) {
			// For each user
			global $wpdb;
			$rows = $wpdb->get_results("SELECT ID FROM " . $wpdb->users);
			foreach ($rows as $row) {
				try {
					$count = 0;
					$skip = 0;
					$notify = false;
					$scheduled = false;

					// Check if enabled
					if (get_usermeta($row->ID,  c_wpmm_meta_sms_enable) && get_usermeta($row->ID,  c_wpmm_meta_sms_notify)) {
						$notify = true;

						// Check schedule
						if ($this->wpmm_is_scheduled($row->ID)) {
							$scheduled = true;

							// Fetch mail
							$list = $this->wpmm_mail_operation($row->ID, 'CRON');
							$count = count($list);

							// Process mail
							for ($i = 0; $i < count($list); $i++) {
								// Process message
								if (!$list[$i]['bulk'] && $list[$i]['id'] && $list[$i]['new']) {
									// Get data
									$from = $this->wpmm_readable_addr($list[$i]['from']);
									$subj = $this->wpmm_trimall($list[$i]['subject']);
									$text = '';
									if (isset($list[$i]['text']))
										$text = $this->wpmm_trimall($list[$i]['text']);

									// Build SMS
									$sepa = get_usermeta($row->ID, c_wpmm_meta_sms_separator);
									if (!$sepa)
										$sepa = ' ';
									$to = get_usermeta($row->ID, c_wpmm_meta_sms_to);
									$msg = $from . $sepa . $subj . $sepa . $text;

									// Send SMS
									if (!$debug)
										$this->wpmm_send_sms($row->ID, $to, $msg);
								}
								else
									$skip++;
							}
						}
					}

					// Build summary
					$summary = ($notify ? '' : 'no ') . 'notify';
					$summary .= ($scheduled ? ' ' : ' un') . 'scheduled';
					if ($scheduled)
						$summary .= ' ' . $count . ' messages ' . $skip . ' skipped';
					$this->wpmm_log($row->ID, 'info', $summary);
				}
				catch (Exception $e) {
					$this->wpmm_log($row->ID, 'error', $e->getMessage());
				}
			}
		}

		// Helper check SMS schedule
		function wpmm_is_scheduled($user_ID) {
			$result = false;
			$now = time();
			$schedule = get_usermeta($user_ID, c_wpmm_meta_sms_schedule);
			foreach (explode("\n", $schedule) as $line) {
				$entry = trim($line);
				if ($entry) {
					$on = true;
					$hit = false;
					if (substr($entry, 0, 1) == '-') {
						$on = false;
						$entry = substr($entry, 1);
					}
					else if (substr($entry, 0, 1) == '+')
						$entry = substr($entry, 1);
					$time = strtotime($entry);
					if ($now >= $time) {
						$hit = true;
						$result = $on;
					}

					$msg = 'Schedule ' . ($on ? '+' : '-') . ' ' . date('r', $time);
					$msg .= ' ' . ($hit ? 'hit' : 'skip');
					$msg .= ' ' . ($result ? 'on' : 'off');
					$this->wpmm_log($user_ID, 'verbose', $msg);
				}
			}
			return $result;
		}

		// Handle ajax calls
		function wpmm_check_ajax() {
			if (isset($_REQUEST[c_wpmm_action_arg])) {
				// Send header
				@header('Content-Type: text/html; charset=' . get_option('blog_charset'));
				
				// Security check
				$nonce = $_REQUEST[c_wpmm_param_nonce];
				if (!wp_verify_nonce($nonce, c_wpmm_nonce_ajax))
					die('Unauthorized');

				// Get current user
				global $user_ID;
				get_currentuserinfo();

				// Load text domain
				load_plugin_textdomain(c_wpmm_text_domain, false, basename(dirname($this->main_file)));

				// Get message list
				if($_GET[c_wpmm_action_arg] == c_wpmm_action_list)
					$this->wpmm_ajax_list_messages($user_ID);

				// Get message
				else if ($_GET[c_wpmm_action_arg] == c_wpmm_action_msg)
					$this->wpmm_ajax_get_message($user_ID);

				// Send message
				else if ($_POST[c_wpmm_action_arg] == c_wpmm_action_send)
					$this->wpmm_ajax_send_message($user_ID);

				// Send SMS
				else if ($_POST[c_wpmm_action_arg] == c_wpmm_action_sms) {
					$this->wpmm_ajax_send_sms($user_ID);
					exit();
				}

				// Manual cron
				else if ($_GET[c_wpmm_action_arg] == c_wpmm_action_cron) {
					$this->wpmm_cron(true);
					$this->wpmm_ajax_show_log($user_ID);
				}

				// Delete message
				else if ($_POST[c_wpmm_action_arg] == c_wpmm_action_del)
					$this->wpmm_ajax_delete_message($user_ID);

				// Log
				else if ($_GET[c_wpmm_action_arg] == c_wpmm_action_log)
					$this->wpmm_ajax_show_log($user_ID);

				// Headers
				else if ($_GET[c_wpmm_action_arg] == headers)
					$this->wpmm_ajax_get_headers($user_ID);

				// Otherwise
				else
					die('Unknown request');
					
				exit();
			}
		}

		// Helper ajax fetch message list
		function wpmm_ajax_list_messages($user_ID) {
			try {
				// Check mail
				$cache = ($_GET[c_wpmm_param_cache] == 'true');
				$list = $this->wpmm_mail_operation($user_ID, $cache ? 'LIST' : 'CHECK');

				// Print header
				echo '<table><tr>';
				echo '<td>&nbsp;</td>';	// Headers
				echo '<td>&nbsp;</td>'; // Delete
				echo '<td><span class="wpmm-list-title">' . __('Date', c_wpmm_text_domain) . '</span></td>';
				echo '<td><span class="wpmm-list-title">' . __('From', c_wpmm_text_domain) . '</span></td>';
				echo '<td><span class="wpmm-list-title">' . __('Subject', c_wpmm_text_domain) . '</span></td></tr>';

				// Print message list
				$p = 0;
				for ($i = 0; $i < count($list); $i++) {
					// List message
					echo '<tr';
					$classes = array();
					if ($list[$i]['bulk'])
						$classes[] = 'wpmm-bulk';
					if ($list[$i]['new'])
						$classes[] = 'wpmm-new-mail';
					if (count($classes))
						echo ' class="' . implode(' ', $classes) . '"';
					echo ' data-id="' . $this->wpmm_format_data($list[$i]['id']) . '"';
					echo ' data-from="' . $this->wpmm_format_data($this->wpmm_format_addr($list[$i]['from'])) . '"';
					echo ' data-subj="' . $this->wpmm_format_data($list[$i]['subject']) . '"';
					echo ' data-to="' . $this->wpmm_format_data($this->wpmm_format_addr($list[$i]['to'])) . '"';
					echo ' data-date="' . ($list[$i]['date'] ? $this->wpmm_format_data($list[$i]['date']) : '') . '"';
					echo ' data-reply="' . $this->wpmm_format_data($this->wpmm_format_addr($list[$i]['reply'] ? $list[$i]['reply'] : $list[$i]['from'])) . '">';
					echo '<td><a class="wpmm-headers" href="#">';
					echo '<img src="' . $this->plugin_url . '/img/Info_Simple_bw.png" height="10px" alt="info"></img>';
					echo '</a></td>';
					echo '<td><a class="wpmm-delete" href="#">';
					echo '<img src="' . $this->plugin_url . '/img/Pictogram_voting_delete.png" height="10px" alt="info"></img>';
					echo '</a></td>';
					echo '<td>' . ($list[$i]['date'] ? date(get_option(c_wpmm_option_time_format), strtotime($list[$i]['date'])) : '') . '</td>';
					echo '<td>' . htmlspecialchars($this->wpmm_readable_addr($list[$i]['from'])) . '</td>';
					echo '<td><a class="wpmm-subj" href="#">';
					if ($list[$i]['attachment'])
						echo '<img src="' . $this->plugin_url . '/img/Gnome-mail-attachment.png" height="10px" alt="info"></img>';
					echo htmlspecialchars($list[$i]['subject']);
					echo '</a></td>';
					echo '</tr>';
				}
				echo '</table>';
			}
			catch (Exception $e) {
				$this->wpmm_log($user_ID, 'error', $e->getMessage());
				echo '<span class="wpmm-notice">' . htmlspecialchars($e->getMessage()) . '</span>';
			}
		}

		// Helper ajax fetch single message
		function wpmm_ajax_get_message($user_ID) {
			try {
				// Receive message
				$msgid = $_GET[c_wpmm_param_msgid];
				$list = $this->wpmm_mail_operation($user_ID, 'GET', $msgid);
				if (count($list))
					if (isset($list[0]['text']))
						echo '<pre>' . $list[0]['text'] . '</pre>';
					else
						echo '<span class="wpmm-notice">' . __('n/a', c_wpmm_text_domain) . '</span>';
				else
					echo '<span class="wpmm-notice">' . __('Gone', c_wpmm_text_domain) . '</span>';
			}
			catch (Exception $e) {
				$this->wpmm_log($user_ID, 'error', $e->getMessage());
				echo '<span class="wpmm-notice">' . htmlspecialchars($e->getMessage()) . '</span>';
			}
		}

		// Helper ajax send message
		function wpmm_ajax_send_message($user_ID) {
			try {
				// Get paramaters
				$to = $this->wpmm_parse_addr($_POST[c_wpmm_param_to]);
				$cc = $this->wpmm_parse_addr($_POST[c_wpmm_param_cc]);
				$subj = $_POST[c_wpmm_param_subj];
				$text = $_POST[c_wpmm_param_text];

				// Send email
				$result = $this->wpmm_send_email($user_ID, $to, $cc, $subj, $text);
				if ($result == 'OK')
					echo __('Sent to', c_wpmm_text_domain) . ' ' . htmlspecialchars($this->wpmm_format_addr($to));
				else
					echo htmlspecialchars($result);
			}
			catch (Exception $e) {
				$this->wpmm_log($user_ID, 'error', $e->getMessage());
				echo htmlspecialchars($e->getMessage());
			}
		}

		// Helper ajax send SMS
		function wpmm_ajax_send_sms($user_ID) {
			$phone = $_POST[c_wpmm_param_phone];
			$text = $this->wpmm_trimall($_POST[c_wpmm_param_text]);
			$result = $this->wpmm_send_sms($user_ID, $phone, $text);
			if ($result == 'OK')
				echo __('Sent to', c_wpmm_text_domain) . ' ' . htmlspecialchars($phone);
			else
				echo $result;
		}

		// Helper ajax delete message
		function wpmm_ajax_delete_message($user_ID) {
			try {
				// Search message
				$found = false;
				$msgid = $_POST[c_wpmm_param_msgid];
				$list = $this->wpmm_mail_operation($user_ID, 'DELETE', $msgid);
				$found = (count($list) > 0);
				echo ($found ? __('OK', c_wpmm_text_domain) : __('Gone', c_wpmm_text_domain));
			}
			catch (Exception $e) {
				$this->wpmm_log($user_ID, 'error', $e->getMessage());
				echo htmlspecialchars($e->getMessage());
			}
		}

		// Helper ajax show log
		function wpmm_ajax_show_log($user_ID) {
			global $wpdb;

			// Clear log
			$clear = $_GET[c_wpmm_param_clear];
			$clear = isset($clear) && $clear == 'true';
			if ($clear) {
				$sql = "DELETE FROM " . $wpdb->prefix . c_wpmm_table_name;
				$sql .= " WHERE user=" . $user_ID;
				if ($wpdb->query($sql) === false)
					$wpdb->print_error();
				$this->wpmm_log($user_ID, 'info', 'Log cleared');
			}

			// Show header
			global $user_login;
			get_currentuserinfo();
			echo 'User: ' . $user_login . '<br />';
			echo 'Last check: ' . date('r', $_SESSION[c_wpmm_session_age]) . '<br />';
			echo 'Next check: ' . date('r', wp_next_scheduled('wpmm_cron')) . '<br />';
			echo '<br />';

			// Show log
			$sql = "SELECT time, severity, function, text FROM " . $wpdb->prefix . c_wpmm_table_name;
			$sql .= " WHERE user=" . $user_ID . " ORDER BY id DESC";
			$rows = $wpdb->get_results($sql);
			foreach ($rows as $row)
				echo $row->time . ' ' . $row->severity . ' ' . htmlspecialchars($row->function) . ' ' . htmlspecialchars($row->text) . '<br />';
		}

		// Helper ajax get headers
		function wpmm_ajax_get_headers($user_ID) {
			try {
				// Receive message
				$msgid = $_GET[c_wpmm_param_msgid];
				$list = $this->wpmm_mail_operation($user_ID, 'HEADERS', $msgid);
				if (count($list))
					if (isset($list[0]['headers'])) {
						echo '<table>';
						foreach ($list[0]['headers'] as $header) {
							echo '<tr><td colspan="2"><span class="wpmm-header-type">';
							echo htmlspecialchars(strtok($header['type'], ';')) . '</span></td></tr>';
							foreach ($header['entries'] as $entry) {
								echo '<tr><td><span class="wpmm-header-name">' . htmlspecialchars($entry['name']) . ':</span></td>';
								echo '<td><span class="wpmm-header-value">' . htmlspecialchars($entry['value']) . '</span></td></tr>';
							}
						}
						echo '</table>';
					}
					else
						echo '<span class="wpmm-notice">' . __('n/a', c_wpmm_text_domain) . '</span>';
				else
					echo '<span class="wpmm-notice">' . __('Gone', c_wpmm_text_domain) . '</span>';
			}
			catch (Exception $e) {
				$this->wpmm_log($user_ID, 'error', $e->getMessage());
				echo '<span class="wpmm-notice">' . htmlspecialchars($e->getMessage()) . '</span>';
			}
		}

		// Helper mail operations
		function wpmm_mail_operation($user_ID, $operation, $param = null) {
			$list = array();
			$this->wpmm_log($user_ID, 'verbose', $operation);

			// Check cache
			$lkey = c_wpmm_session_cache . $user_ID;
			if ($operation == 'LIST') {
				if (isset($_SESSION[$lkey])) {
					$age = $_SESSION[c_wpmm_session_age];
					$maxage = get_option(c_wpmm_option_cache_maxage);
					if ($maxage <= 0)
						$maxage = 15;
					if (time() - $age < $maxage * 60)
						return $_SESSION[$lkey];
				}
			}
			else if ($operation == 'GET') {
				$mkey = c_wpmm_session_cache . '_' . $param;
				if (isset($_SESSION[$mkey])) {
					$list[0]['text'] = $_SESSION[$mkey];
					return $list;
				}
			}

			// Get message headers
			else if ($operation == 'HEADERS') {
				if (isset($_SESSION[$lkey])) {
					$slist = $_SESSION[$lkey];
					for ($i = 0 ; $i < count($slist); $i++)
						if ($slist[$i]['id'] == $param) {
							$list[0]['id'] = $param;
							$list[0]['headers'] = $slist[$i]['headers'];
							break;
						}
				}
				return $list;
			}

			try {
				// Get known messages
				if ($operation == 'LIST' || $operation == 'CHECK' || $operation == 'CRON') {
					$known = get_usermeta($user_ID, c_wpmm_meta_known);
					if (!$known) $known = array();
					$known_new = array();
				}

				// Connect to storage
				$rx = get_usermeta($user_ID, c_wpmm_meta_mail_rx);
				if ($rx == 'POP3') {
					// Get configuration
					$host = get_usermeta($user_ID, c_wpmm_meta_pop3_host);
					$port = get_usermeta($user_ID, c_wpmm_meta_pop3_port);
					$user = get_usermeta($user_ID, c_wpmm_meta_pop3_user);
					$pwd = get_usermeta($user_ID, c_wpmm_meta_pop3_pwd);
					$ssl = get_usermeta($user_ID, c_wpmm_meta_pop3_ssl);

					// Build configuration
					$config = array();
					$config['host'] = $host;
					if ($port)
						$config['port'] = $port;
					$config['user'] = $user;
					$config['password'] = $pwd;
					if ($ssl)
						$config['ssl'] = $ssl;

					// Connect to storage
					$mail = new Zend_Mail_Storage_Pop3($config);
				}
				else if ($rx == 'IMAP') {
					// Get configuration
					$host = get_usermeta($user_ID, c_wpmm_meta_imap_host);
					$port = get_usermeta($user_ID, c_wpmm_meta_imap_port);
					$user = get_usermeta($user_ID, c_wpmm_meta_imap_user);
					$pwd = get_usermeta($user_ID, c_wpmm_meta_imap_pwd);
					$ssl = get_usermeta($user_ID, c_wpmm_meta_imap_ssl);
					$folder = get_usermeta($user_ID, c_wpmm_meta_imap_folder);

					// Build configuration
					$config = array();
					$config['host'] = $host;
					if ($port)
						$config['port'] = $port;
					$config['user'] = $user;
					$config['password'] = $pwd;
					if ($ssl)
						$config['ssl'] = $ssl;
					if ($folder)
						$config['folder'] = $ssl;

					// Connect to storage
					$mail = new Zend_Mail_Storage_Imap($config);
				}
				else
					throw new Exception(__('Not configured', c_wpmm_text_domain));

				// Fetch message list
				if ($mail) {
					for ($i = $mail->countMessages(); $i > 0; $i--) {
						// Get message data
						$msg_id = $this->wpmm_get_header($mail[$i], 'message-id');
						$msg_date = $this->wpmm_get_header($mail[$i], 'date');
						$msg_from = $this->wpmm_get_header($mail[$i], 'from');
						$msg_to = $this->wpmm_get_header($mail[$i], 'to');
						$msg_subj = $this->wpmm_get_header($mail[$i], 'subject');

						// Generate message id
						$id = md5($msg_id . $msg_date . $msg_from . $msg_to . $msg_subj);

						// Delete message
						if ($operation == 'DELETE') {
							if ($param && $param == $id) {
								// Delete message
								$mail->removeMessage($i);

								// Update cache
								if (isset($_SESSION[$lkey])) {
									$slist = $_SESSION[$lkey];
									for ($i = 0 ; $i < count($slist); $i++)
										if ($slist[$i]['id'] == $param) {
											unset($slist[$i]);
											$_SESSION[$lkey] = array_values($slist);
											break;
										}
								}

								// Prepare result
								$list[0]['id'] = $param;
								break;
							}
						}

						// Get message
						else if ($operation == 'GET') {
							if ($param && $param == $id) {
								// Get body
								$body = $this->wpmm_get_body($mail[$i]);
								if ($body) {
									$text = $this->wpmm_get_decoded_text($body);

									// Convert html
									$ctheader = $this->wpmm_get_header($body, 'Content-Type');
									if (strtolower(strtok($ctheader, ';')) == 'text/html')
										$text = $this->wpmm_html2text($text);

									// Prepare result
									$list[0]['text'] = $text;
									$_SESSION[$mkey] = $text;
								}

								// Update cache
								if (isset($_SESSION[$lkey])) {
									$slist = $_SESSION[$lkey];
									for ($i = 0 ; $i < count($slist); $i++)
										if ($slist[$i]['id'] == $param) {
											$slist[$i]['new'] = false;
											$_SESSION[$lkey] = $slist;
											break;
										}
								}

								// Prepare result
								$list[0]['id'] = $param;
								break;
							}
						}
						else {
							// Get message meta
							$idx = count($list);
							$list[$idx]['id'] = $id;
							$list[$idx]['from'] = $this->wpmm_parse_addr($msg_from);
							$list[$idx]['to'] = $this->wpmm_parse_addr($msg_to);
							$list[$idx]['date'] = $msg_date;
							$list[$idx]['reply'] = $this->wpmm_parse_addr($this->wpmm_get_header($mail[$i], 'Reply-To'));

							// Check for bulk
							$bulk = (strpos($msg_subj, '[Bulk]') === 0);
							if ($bulk)
								$msg_subj = substr($msg_subj, 7);

							// Check empty subject
							if (!$msg_subj || $msg_subj == '')
								$msg_subj = '>>';

							// Check if new
							$new = !in_array($id, $known);

							$list[$idx]['bulk'] = $bulk;
							$list[$idx]['subject'] = $msg_subj;
							$list[$idx]['new'] = $new;

							// List headers
							$message = $mail[$i];
							$headers = array();
							$headers[] = $this->wpmm_list_headers($message);
							if ($message->isMultipart())
								foreach (new RecursiveIteratorIterator($message) as $part)
									$headers[] = $this->wpmm_list_headers($part);
							$list[$idx]['headers'] = $headers;

							// Check attachments
							$attachment = false;
							foreach ($headers as $header) {
								$htype = explode('/', $header['type']);
								if ($htype[0] != 'text' && $htype[0] != 'multipart') {
									$attachment = true;
									break;
								}
							}
							$list[$idx]['attachment'] = $attachment;

							// Cron: get message text
							if ($operation == 'CRON') {
								if (!$bulk && $new) {
									// Get body
									$body = $this->wpmm_get_body($mail[$i]);
									if ($body) {
										$text = $this->wpmm_get_decoded_text($body);

										// Convert html
										$ctheader = $this->wpmm_get_header($body, 'Content-Type');
										if (strtolower(strtok($ctheader, ';')) == 'text/html')
											$text = $this->wpmm_html2text($text);

										// Prepare result
										$list[$idx]['text'] = $text;
									}
								}
							}
						}

						// Update known messages
						if ($operation == 'LIST' || $operation == 'CHECK' || $operation == 'CRON')
							$known_new[] = $id;
					}
				}

				// Update known messages
				if ($operation == 'LIST' || $operation == 'CHECK' || $operation == 'CRON')
					update_usermeta($user_ID, c_wpmm_meta_known, $known_new);

				// Update cache
				if ($operation == 'LIST' || $operation == 'CHECK') {
					$_SESSION[$lkey] = $list;
					$_SESSION[c_wpmm_session_age] = time();
				}

				$this->wpmm_log($user_ID, 'info', $operation . ' ' . count($list) . ' records');
			}
			catch (Exception $e) {
				$this->wpmm_log($user_ID, 'error', $e->getMessage());
				throw $e;
			}

			return $list;
		}

		// Helper send email
		function wpmm_send_email($user_ID, $to, $cc, $subj, $text) {
			try
			{
				// Select transport
				$tx = get_usermeta($user_ID, c_wpmm_meta_mail_tx);
				if ($tx == 'Sendmail')
					Zend_Mail::setDefaultTransport(new Zend_Mail_Transport_Sendmail());
				else if ($tx == 'SMTP') {
					// Get configuration
					$host = get_usermeta($user_ID, c_wpmm_meta_smtp_host);
					$port = get_usermeta($user_ID, c_wpmm_meta_smtp_port);
					$auth = get_usermeta($user_ID, c_wpmm_meta_smtp_auth);
					$user = get_usermeta($user_ID, c_wpmm_meta_smtp_user);
					$pwd = get_usermeta($user_ID, c_wpmm_meta_smtp_pwd);
					$ssl = get_usermeta($user_ID, c_wpmm_meta_smtp_ssl);

					// Build configuration
					$config = array();
					if ($port)
						$config['port'] = $port;
					if ($auth) {
						$config['auth'] = $auth;
						$config['username'] = $user;
						$config['password'] = $pwd;
					}
					if ($ssl)
						$config['ssl'] = $ssl;

					// Setup transport
					Zend_Mail::setDefaultTransport(new Zend_Mail_Transport_Smtp($host, $config));
				}

				// Get data
				$name = get_usermeta($user_ID, c_wpmm_meta_mail_name);
				$addr = get_usermeta($user_ID, c_wpmm_meta_mail_addr);

				// Build message
				$mail = new Zend_Mail(get_option('blog_charset'));
				$mail->setHeaderEncoding(Zend_Mime::ENCODING_BASE64);
				$mail->setBodyText($text);
				$mail->setFrom($addr, $name);
				$mail->setReplyTo($addr, $name);
				$mail->addTo($to['email'], $to['name']);
				if ($cc)
					$mail->addCc($cc['email'], $cc['name']);
				$mail->setSubject($subj);
				$mail->addHeader('X-Mailer', 'WP-Mini-Mail');

				// Send message
				$mail->send();
				$result = 'OK';
			}
			catch (Exception $e) {
				$result = $e->getMessage();
			}

			// Process result
			$this->wpmm_log($user_ID, 'info', $this->wpmm_format_addr($to) . '/' . $this->wpmm_format_addr($cc) . ': ' . htmlspecialchars($result));
			return $result;
		}

		// Helper send SMS
		function wpmm_send_sms($user_ID, $to, $text) {
			$ret = false;

			// Truncate message if necessary
			if (strlen($text) > c_wpmm_sms_max_size)
				$text = substr($text, 0, c_wpmm_sms_max_size);

			// Build query
			$query = http_build_query(array(
				'username' => get_usermeta($user_ID, c_wpmm_meta_sms_user),
				'password' => get_usermeta($user_ID, c_wpmm_meta_sms_pwd),
				'from' => get_usermeta($user_ID, c_wpmm_meta_sms_from),
				'to' => $to,
				'text' => $text
			));

			// Get time out
			$timeout = intval(get_option(c_wpmm_option_http_timeout));
			if (!$timeout || $timeout <= 0) 
				$timeout = 30;

			// Build query context
			$context = stream_context_create(array(
				'http' => array(
					'method'  => 'GET',
					'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
					'timeout' => $timeout
				)
			));

			// Run query
			$url = get_usermeta($user_ID, c_wpmm_meta_sms_url);
			$xml = @file_get_contents($url . '?' . $query, false, $context);
			if ($xml) {
				// Parse result
				$parser = new XMLParser($xml);
				$parser->Parse();

				// Get result
				$result = false;
				$description = false;
				$endcause = false;
				foreach ($parser->document->tagChildren as $child) {
					if ($child->tagName == 'result')
						$result = $child->tagData;
					else if ($child->tagName == 'description')
						$description = $child->tagData;
					else if ($child->tagName == 'endcause')
						$endcause = $child->tagData;
				}

				// Check result
				$ret = ($result ? 'OK' : $endcause . '/' . $description);
			}
			else {
				$error = error_get_last();
				$ret = $error['message'];
			}

			// Process result
			$this->wpmm_log($user_ID, 'info', $to . ': ' . $ret . ' "' . $text . '"');
			return $ret;
		}

		// Helper get decoded MIME header
		function wpmm_get_header($part, $name) {
			$value = false;
			if ($part->headerExists($name)) {
				$value = $part->getHeader($name, 'string');

				// Workaround Yahoo!
				$bulk = false;
				if ($name == 'subject')
					if (strpos($value, '[Bulk]') === 0) {
						$bulk = true;
						$value = substr($value, 7);
					}

				// "=?charset?encoding?encoded text?="
				$cencoding = 'ISO-8859-1';
				$q = strpos($value, '=?');
				if (($q === 0 || $q > 0) && strpos($value, '?=')) {
					$q = explode('?', $value);
					$cencoding = $q[1];
					$value = mb_decode_mimeheader($value);
				}

				// Convert character encoding
				$value = mb_convert_encoding($value, get_option('blog_charset'), $cencoding);

				// Restore bulk flag
				if ($bulk)
					$value = '[Bulk] ' . $value;
			}
			else {
				// Workaround if no date
				if ($name == 'date' && $part->headerExists('received')) {
					$received = $part->getHeader('received', 'array');
					if (count($received) > 0) {
						$q = explode(';', $received[0]);
						$value = $q[count($q) - 1];
					}
				}
			}
			return $value;
		}

		// Helper list headers
		function wpmm_list_headers($part) {
			$entries = array();
			foreach ($part->getHeaders() as $name => $value) {
				if (is_string($value))
					$entries[] = array(name => $name, value => $value);
				else
					foreach ($value as $entry)
						$entries[] = array(name => $name, value => $entry);
			}
			return array(type => $this->wpmm_get_header($part, 'Content-Type'), entries => $entries);
		}

		// Helper parse address
		function wpmm_parse_addr($addr) {
			$addr = trim($addr);
			if ($addr) {
				$x = explode(',', $addr);
				$addr = $x[0];
				$result = array();
				$lt = strpos($addr, '<');
				if ($lt === false) {
					$name = '';
					$email = $addr;
				}
				else {
					$name = substr($addr, 0, $lt - 1);
					$email = substr($addr, $lt + 1);
				}
				$result['name'] = trim(str_replace('"', '', $name));
				$result['email'] = trim(str_replace('>', '', $email));
				return $result;
			}
			return false;
		}

		// Helper create readable address
		function wpmm_readable_addr($addr) {
			return ($addr ? $addr['name'] ? $addr['name'] : $addr['email'] : false);
		}

		// Helper create header address
		function wpmm_format_addr($addr) {
			return ($addr['name'] ? $addr['name'] . ' <' . $addr['email'] . '>' : $addr['email']);
		}

		function wpmm_address_book_extra($book) {
			global $wpdb;
			$sql = "SELECT ID FROM " . $wpdb->users;
			$rows = $wpdb->get_results($sql);
			foreach ($rows as $row) {
				$user = get_userdata($row->ID);
				if ($user->first_name || $user->last_name)
					$name = $user->first_name . ' ' .$user->last_name;
				else
					$name = $user->user_nicename;
				$book[] = $name . ' <' . $user->user_email . '>';
			}
			return $book;
		}

		function wpmm_format_data($text) {
			return str_replace('"', '&#34', $text);
		}

		// Helper get message content
		function wpmm_get_body($message) {
			if ($message->isMultipart()) {
				$partText = null;
				$partHtml = null;
				foreach (new RecursiveIteratorIterator($message) as $part) {
					$content_type = strtolower(strtok($this->wpmm_get_header($part, 'Content-Type'), ';'));
					if ($partText == null && $content_type == 'text/plain')
						$partText = $part;
					else if ($partHtml == null && $content_type == 'text/html')
						$partHtml = $part;
				}
				if ($partText != null)
					return $partText;
				else if ($partHtml != null)
					return $partHtml;
				else
					return null;
			}
			else {
				$content_type = strtolower(strtok($this->wpmm_get_header($message, 'Content-Type'), ';'));
				if ($content_type == 'text/plain' || $content_type == 'text/html')
					return $message;
				else
					return null;
			}
		}

		// Helper message decoding
		function wpmm_get_decoded_text($body) {
			$text = $body->getContent();

			// Check transfer encoding
			$tencoding = strtolower($this->wpmm_get_header($body, 'content-transfer-encoding'));
			if ($tencoding == 'base64')
				$text = base64_decode($text);
			if ($tencoding == 'quoted-printable')
				$text = quoted_printable_decode($text);

			// Check character encoding
			$cencoding = 'ISO-8859-1';
			foreach (explode(';', $this->wpmm_get_header($body, 'Content-Type')) as $nv) {
				$nvs = explode('=', $nv);
				$name = strtolower(trim($nvs[0]));
				if ($name == 'charset') {
					$cencoding = trim($nvs[1]);
					break;
				}
			}
			$cencoding = str_replace('"', '', $cencoding);
			return mb_convert_encoding($text, get_option('blog_charset'), $cencoding);
		}

		// Helper check environment
		function wpmm_check_prerequisites() {
			// Check PHP version
			if (version_compare(PHP_VERSION, '5.2.4', '<'))
				die('Mini Mail requires at least PHP 5.2.4, installed version is ' . PHP_VERSION);

			// Check WordPress version
			global $wp_version;
			if (version_compare($wp_version, '2.7') < 0)
				die('Mini Mail requires at least WordPress 2.7, installed version is ' . $wp_version);

			// Check basic prerequisities
			WPMiniMail::wpmm_check_function('register_activation_hook');
			WPMiniMail::wpmm_check_function('register_deactivation_hook');
			WPMiniMail::wpmm_check_function('add_action');
			WPMiniMail::wpmm_check_function('add_filter');
			WPMiniMail::wpmm_check_function('wp_register_style');
			WPMiniMail::wpmm_check_function('wp_enqueue_style');
			WPMiniMail::wpmm_check_function('wp_register_script');
			WPMiniMail::wpmm_check_function('wp_enqueue_script');
			WPMiniMail::wpmm_check_function('wp_next_scheduled');
			WPMiniMail::wpmm_check_function('base64_decode');
			WPMiniMail::wpmm_check_function('quoted_printable_decode');
			WPMiniMail::wpmm_check_function('mb_convert_encoding');
			WPMiniMail::wpmm_check_function('mb_decode_mimeheader');
			WPMiniMail::wpmm_check_function('md5');
		}

		function wpmm_check_function($name) {
			if (!function_exists($name))
				die('Required function "' . $name . '" does not exist');
		}

		// Helper clear cache
		function wpmm_clear_cache() {
			foreach($_SESSION as $key => $value)
				if (strpos($key, c_wpmm_session_cache) === 0)
					unset($_SESSION[$key]);
			unset($_SESSION[c_wpmm_session_age]);
		}

		// Helper log message
		function wpmm_log($user_ID, $severity, $text) {
			if (get_option(c_wpmm_option_debug) || $severity != 'verbose') {
				global $wpdb;
				$bt = debug_backtrace();
				$sql = 'INSERT INTO ' . $wpdb->prefix . c_wpmm_table_name . ' (time, user, severity, function, text)';
				$sql .= ' VALUES (now(), ' . $user_ID . ',"' . $severity . '","' . $wpdb->escape($bt[1]['function']) . '","' .$wpdb->escape($text) . '")';
				if ($wpdb->query($sql) === false)
					$wpdb->print_error();
			}
		}

		// Helper change file name extension
		function change_extension($filename, $new_extension) {
			return preg_replace('/\..+$/', $new_extension, $filename);
		}

		// Helper convert html to text
		function wpmm_html2text($text){
			$h2t = new html2text($text);
			return $h2t->get_text();
		}

		// Helper to remove extra white space
		function wpmm_trimall($str, $charlist = "\t\n\r\0\x0B") {
			return trim(ereg_replace(' +', ' ', str_replace(str_split($charlist), ' ', $str)));
		}
	}
}

?>
